/*
 File: enumerate_grammarsym.cpp
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#include "enumerate_grammar.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_enumerate_grammar;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Cenumerate_grammar::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rfirst_set_rules_:{
       Rfirst_set_rules* sym;
     if(re->rule_ == 0){
       sym = new Rfirst_set_rules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfirst_set_rules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_:{
       Rrule* sym;
     if(re->rule_ == 0){
       sym = new Rrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rsubrule_:{
       Rsubrule* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Relements_:{
       Relements* sym;
     if(re->rule_ == 0){
       sym = new Relements(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relements*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Relements_:{
       Relements* sym;
     if(re->rule_ == 0){
       sym = new Relements(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relements*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs3_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs4_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr4();
     return;}
    case rhs5_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr5();
     return;}
    default: return;
   }
}
